Code Review
===========

A guide for reviewing code and having your code reviewed.

Everyone
--------

* Accept that many programming decisions are opinions. Discuss tradeoffs, which
  you prefer, and reach a resolution quickly.
* Ask questions; don't make demands. ("What do you think about naming this
  `:user_id`?")
* Ask for clarification. ("I didn't understand. Can you clarify?")
* Avoid selective ownership of code. ("mine", "not mine", "yours")
* Avoid using terms that could be seen as referring to personal traits. ("dumb",
  "stupid"). Assume everyone is intelligent and well-meaning.
* Be explicit. Remember people don't always understand your intentions online.
* Be humble. ("I'm not sure - let's look it up.")
* Don't use hyperbole. ("always", "never", "endlessly", "nothing")
* Don't use sarcasm.
* Keep it real. If emoji, animated gifs, or humor aren't you, don't force them.
  If they are, use them with aplomb.
* Talk in person if there are too many "I didn't understand" or "Alternative
  solution:" comments. Post a follow-up comment summarizing offline discussion.

Having Your Code Reviewed
-------------------------

* Be grateful for the reviewer's suggestions. ("Good call. I'll make that
  change.")
* Don't take it personally. The review is of the code, not you.
* Explain why the code exists. ("It's like that because of these reasons. Would
  it be more clear if I rename this class/file/method/variable?")
* Extract some changes and refactorings into future tickets/stories.
* Link to the code review from the JIRA ticket/story. ("Ready for review:
    https://gitlab.com/ucsdlibrary/development/hifive/-/merge_requests/10")
* Send a comment in the MR to the Development group members, asking for
  feedback.
* Push commits based on earlier rounds of feedback as isolated commits to the branch. Do not squash until the branch is ready to merge. Reviewers should be able to read individual updates based on their earlier feedback.
* Seek to understand the reviewer's perspective.
* Try to respond to every comment.

Reviewing Code
--------------

Merge Requests should be reviewed, and signed off, by at least two members of the development team. This is to facilitate shared knowledge across the group about updates to the entire codebase for a project, as well as ensuring we follow current best practices as consistently as possible.

Understand why the code is necessary (bug, user experience, refactoring). Then:

* Communicate which ideas you feel strongly about and those you don't.
* Identify ways to potentially refactor and simplify the code while still solving the problem.
* If discussions turn too philosophical or academic, bring up the discussion in
  the next Development Team Meeting. In the meantime, let the author make the final decision on alternative implementations.
* Offer alternative implementations, but assume the author already considered
  them. ("What do you think about using a custom validator here?")
* Seek to understand the author's perspective.
* Wait to merge the branch until Bamboo plan tells you the test suite is green in the branch.
* Merge once you feel confident in the code and its impact on the project.
* Sign off on the merge request with a :thumbsup: or "Ready to merge" comment.
* The last team member to sign off should merge the merge request.

Style Comments
--------------

Reviewers should comment on missed [style](https://github.com/bbatsov/ruby-style-guide)
guidelines. Example comment:

    [Style](https://github.com/bbatsov/ruby-style-guide)

    > Order resourceful routes alphabetically by name.

An example response to style comments:

    Whoops. Good catch, thanks. Fixed in a4994ec.

If you disagree with a guideline, open an issue on the guides repo rather than
debating it within the code review. In the meantime, apply the guideline.

Scope
-----

Merge Request review should be limited to the context of the requested work in
the JIRA ticket. Reviewers should limit review comments to the code being added or
changed. This allows the Sprint development process to keep moving and target
review on the tasks at hand.

If the Merge Request raises larger issues that extend beyond the scope of the
JIRA ticket, those should be documented in new JIRA tickets for future discussion, prioritization, and implementation.
